//Please read the comments(pakibasa ang mga comments)
#include <genieArduino.h>

#define RESETLINE 4
Genie genie;
char keyvalue[10]; // array to hold keyboard values
char newkeyvalue[10];
char asterisk[9];
int counter = 0;
int counter2 = 0;
int temp;
int temp2;
bool flag;

void setup()
{
  Serial.begin(9600);
  Serial1.begin(9600); // to comminicate with LCD
  genie.Begin(Serial1);
  genie.AttachEventHandler(myGenieEventHandler); 
  pinMode(RESETLINE, OUTPUT);  // Set D4 on Arduino to Output (4D Arduino Adaptor V2 - Display Reset)
  digitalWrite(RESETLINE, 1);  // Reset the Display via D4
  delay(100);
  digitalWrite(RESETLINE, 0);  // unReset the Display via D4

  delay (3500); //let the display start up after the reset (This is important)


}

void loop()
{
  //Process events
  genie.DoEvents();
    
}

void myGenieEventHandler(void)
{
  genieFrame Event;
  genie.DequeueEvent(&Event);

  //If the cmd received is from a Reported Event (Events triggered from the Events tab of Workshop4 objects)
  if (Event.reportObject.cmd == GENIE_REPORT_EVENT)
  {
    if(Event.reportObject.object == GENIE_OBJ_KEYBOARD)
    {
      if (Event.reportObject.index == 0)                              // If keyboard0
      {
        temp = genie.GetEventData(&Event); 
        if(temp >= 48 && temp <= 57 && counter <=9)
        {
          keyvalue[counter] = temp;        // Receive the event data from the keyboard
          genie.WriteStr(0,keyvalue);                         //prints to String Object       
          counter = counter + 1; //increment array
        }
        else if(temp == 8)                              //check if backspace
        {
          counter--;
          keyvalue[counter] = 0;
          genie.WriteStr(0,keyvalue);
        }
        else if(temp == 13)
        {
          for(int x =0; x<counter ; x++)
          {
            Serial.println(keyvalue[x]);
            
          }
          Serial.print("DONE");
          genie.WriteObject(GENIE_OBJ_FORM,0x01,0);
        }
      }
    }
    if (Event.reportObject.index == 1)
    {
      temp2 = genie.GetEventData(&Event);
      if(temp2 >= 48 && temp2 <= 57 && counter2 <=9) 
      {
        newkeyvalue[counter2] = temp2;
        asterisk[counter2] = temp2;
        genie.WriteStr(1,asterisk);
        asterisk[counter2] = '*';
        counter2 = counter2 + 1;
        delay(200);
        genie.WriteStr(1,asterisk);
      }
      else if(temp2 == 8 && counter2 >0)                              //check if backspace
        {
          counter2--;
          newkeyvalue[counter2] = 0;
          asterisk[counter2] = ' ';
          genie.WriteStr(1,asterisk);
        }
      else if(temp2 == 13)
      {
        for(int x =0; x<counter ; x++)
          {
            Serial.println(newkeyvalue[x]);
            
          }
          Serial.print("DONE");
          
        for(int x=0; x<9;x++)
        {
          if(keyvalue[x] == newkeyvalue[x])
          {
            flag = 1;
            Serial.println("PASSED");
          }
          else
          {
            flag = 0;
          }
          if(flag == 0)
          {
            break;
          }
        }
        if(flag == 0)
        {
          genie.WriteStr(2,"INCORRECT PASSWORD");
          delay(2000);
          
        }
        else if(flag == 1)
        {
          genie.WriteStr(2,"CORRECT PASSWORD");
          for(int y=0;y<9;y++)
          {
            newkeyvalue[y] = 0;
            asterisk[y] = 0;
            
          }
          delay(2000);
          flag = 0;
          counter2 = 0;
          genie.WriteStr(1,asterisk);
          genie.WriteObject(GENIE_OBJ_FORM,0x01,0);
        }
      }
    }
  }
        
  
 
}



